from pathlib import Path

from verser.verserLocal.components.increment_functions import increment_version_pypi, next_version_pypi
from verser.verserLocal.components.version_functions import get_current_version, get_next_version
from verser.verserLocal.components.project import Project
from verser.verserLocal.format.format_check import pep_440_strategy

from verser.verserLocal.enums.parts_enum import get_enum_with_value, VersionPartEnum, patch
from verser.verserLocal.verser_ import *

import random


def test_pep_440_strategy(capsys):
    with capsys.disabled():
        assert pep_440_strategy('0.0.1.12') == '0.0.1'


def test_get_next_version(capsys):
    for item in range(3):
        inc = random.choice((True, False,))
        # inc = True
        pre = random.choice((True, False,))
        n = get_next_version(project=Project(version_file_path=Path("verser"),
                                             now_testing=True),
                             increment_=inc,
                             prerelease=pre,
                             verbose=True)
        # assert n is not None
        with capsys.disabled():
            n = get_next_version(
                project=Project(now_testing=True),
                increment_=inc,
                prerelease=pre,
                verbose=True
            )
            # assert n is not None


def test_get_current_version(capsys):
    for item in range(3):
        # inc = random.choice((True, False,))
        inc = True
        pre = random.choice((True, False,))
        # n = get_current_version(project=Project(), increment_=inc, pre_release=pre, verbose=True)
        # assert n is not None
        with capsys.disabled():
            n = get_current_version(project=Project(now_testing=True),
                                    verbose=True,
                                    now_testing=True
                                    )

            # assert n is not None


def test_examples(capsys):
    with capsys.disabled():
        some_examples_instances_from_string()
        some_examples_instances_from_tuple()


def test_increment_version_pypi(capsys):
    with capsys.disabled():
        nv = increment_version_pypi(package_name="rich")
        print(nv)


def test_enum(capsys):
    with capsys.disabled():
        part_enum = get_enum_with_value("minor", VersionPartEnum, patch)
        print(part_enum)
        part_enum = get_enum_with_value("major", VersionPartEnum, patch)
        print(part_enum)
        part_enum = get_enum_with_value("patch", VersionPartEnum, patch)
        print(part_enum)


def test_next_version(capsys):
    with capsys.disabled():
        new_version = next_version_pypi('rich', part='minor')
        print(new_version)


def test_next_version2(capsys):
    with capsys.disabled():
        new_version = next_version_pypi('requests', part='patch')
        print(new_version)


def test_next_version3(capsys):
    with capsys.disabled():
        new_version = next_version_pypi('requests', part='pre')
        print(new_version)
